(function ($) {
  Drupal.behaviors.tencentWeChatBinding = {
    attach: function (context, settings) {
      var basePath = settings.basePath;
      var postUrl = basePath + 'tencent-wechatbinding/bind/result';
      settings.tencent_wechatbinding.intervalId = window.setInterval(bindingPolling, 2000);
      function bindingPolling() {
        $.post(postUrl, {}, function(result) {
          if (result > 0) {
            var successful_message = Drupal.t("Bind WeChat Official Account user Successful!");
            $("#tencent-wechatuser-bind-qr-code").remove();
            $("#tencent-wechatuser-binding-message").html(successful_message);
            clearTimeout(settings.tencent_wechatbinding.intervalId);
          }
        }, "json");
      }
      setTimeout(function () {
        clearTimeout(settings.tencent_wechatbinding.intervalId);
        var warning_message = Drupal.t("Timeout! Please refresh this page to load a new QR Code to bind WeChat Official Account user with your Drupal Account.");
        $("#tencent-wechatuser-binding-message").html(warning_message);
      }, 60 * 1000);
    }
  };
})(jQuery);
